#include <stdio.h>
#include <stdlib.h>

#define N 10 // no. de pontos

/*
  xy: vetor bidimensional com n elementos, contendo os pares [x_i,y_i]
  dd: matriz de tamanho n+1 x n+1 para as diferenças divididas
  n: número de pontos == grau máximo do polinomio
*/


void genDifDiv(double xy[N][2], double dd[N+1][N+1], int n)
{
  int i, j;

  // Zera matriz dd[][]
  for(i=0;i<n+1; i++)
    for(j=1;j<n+1; i++)
      dd[i][j] = 0.0;
  
  // Ordem 0 (zero)
  for(i=0;i<n+1; i++)
    dd[i][0] = xy[i][1];

  // Ordem 1...N
  for(j=1; j<n+1; j++)
    for(i=0;i<n-j; i++)
      dd[i][j] = (dd[i+1][j-1] - dd[i][j-1]) / (xy[i+j][0] - xy[i][0]);
}

